package org.apache.bcel.classfile;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.io.DataInput;
import java.io.DataOutputStream;
import java.io.IOException;
import org.apache.bcel.classfile.Attribute;
import org.apache.bcel.classfile.ConstantClass;
import org.apache.bcel.classfile.ConstantNameAndType;
import org.apache.bcel.classfile.ConstantPool;
import org.apache.bcel.classfile.Visitor;

public class EnclosingMethod extends Attribute {
  private int classIndex;
  
  private int methodIndex;
  
  EnclosingMethod(int nameIndex, int len, DataInput input, ConstantPool cpool) throws IOException {
    this(nameIndex, len, input.readUnsignedShort(), input.readUnsignedShort(), cpool);
  }
  
  private EnclosingMethod(int nameIndex, int len, int classIdx, int methodIdx, ConstantPool cpool) {
    super((byte)18, nameIndex, len, cpool);
    this.classIndex = classIdx;
    this.methodIndex = methodIdx;
  }
  
  public void accept(Visitor v) {
    v.visitEnclosingMethod(this);
  }
  
  public Attribute copy(ConstantPool constantPool) {
    return (Attribute)clone();
  }
  
  public final void dump(DataOutputStream file) throws IOException {
    super.dump(file);
    file.writeShort(this.classIndex);
    file.writeShort(this.methodIndex);
  }
  
  public final ConstantClass getEnclosingClass() {
    return (ConstantClass)getConstantPool().getConstant(this.classIndex, (byte)7, ConstantClass.class);
  }
  
  public final int getEnclosingClassIndex() {
    return this.classIndex;
  }
  
  public final ConstantNameAndType getEnclosingMethod() {
    if (this.methodIndex == 0)
      return null; 
    return (ConstantNameAndType)getConstantPool().getConstant(this.methodIndex, (byte)12, ConstantNameAndType.class);
  }
  
  public final int getEnclosingMethodIndex() {
    return this.methodIndex;
  }
  
  public final void setEnclosingClassIndex(int idx) {
    this.classIndex = idx;
  }
  
  public final void setEnclosingMethodIndex(int idx) {
    this.methodIndex = idx;
  }
}
